
/* ASCII-Tabelle */

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

char zeile[80];

#define SPALTENZAHL 4
#define SPALTENABSTAND 5

#define SO 14
#define SI 15

// Verwendung der Y-Cartridge, HP-Laserjet
// Zeichensatz LINE-PRINTER
// Symbol-Set PCset1, PCext

const char *SET1 = "\x1b&l0O\x1b(s0p16.66h8.5v0s0b0T";
const char *SET2 = "\x1b&l0O\x1b)s0p16.66h8.5v0s0b0T";
const char *NEW_LINE = "\x1b&l6C\n";
const char SET_1 = SI;
const char SET_2 = SO;

void main()
{
  FILE *fp;
  int zeile,spalte,abstand;
  char c;
  
  printf("ASCII-Tabelle fr Drucker(D) oder Word(W)? ");
  do
  { c = toupper(getch());
  } while (!((c=='D')||(c=='W')));
  printf("%c\n",c);
  switch (c)
  {
  case 'D': 
    fp=fopen("ASCII.DRU","w"); 
    fprintf(fp,"%s%s",SET1,SET2);
    fprintf(fp,NEW_LINE);
    break;
  case 'W': 
    fp=fopen("ASCII.TXT","w"); 
    break;
  }

  for (spalte=0; spalte<SPALTENZAHL; spalte++)  // KOPFZEILE
  {
    if (spalte==0)
      fprintf(fp,"");
    else
      fprintf(fp,"");
    fprintf(fp,"DEZHXBIN");
    if (spalte==SPALTENZAHL-1)
    {
      fprintf(fp,"");
      switch (c)
      {
      case 'D':
        fprintf(fp,NEW_LINE);
        break;
      case 'W':
        fprintf(fp,"\n");
        break;
      }
    }
    else
    {
      fprintf(fp,"");
      for (abstand=0; abstand<SPALTENABSTAND; abstand++)
        fprintf(fp,"");
    }
  }

  for (zeile=0; zeile<256/SPALTENZAHL; zeile++)  // ASCII-Tabelle
  {
    for (spalte=0; spalte<SPALTENZAHL; spalte++)
    {
      int i=spalte*(256/SPALTENZAHL)+zeile;
      // printf("zeile: %i, spalte %i, nummer: %i\n",zeile,spalte,i);
      switch (c)
      {
      case 'D':
        if (( (i>=0) && (i<32) ) || ( (i>=128) && (i<128+32) ))
          fprintf(fp,"%c%c%c",SET_2,i+32,SET_1);
        else
          fprintf(fp,"%c",i);
        break;
      case 'W':
        if ( (i>=0) && (i<32) ) 
          fprintf(fp,"%c",i+32);
        else
          fprintf(fp,"%c",i);
        break;
      }
      fprintf(fp,"%03i %02X %08b",i,i,i);
      if (spalte==SPALTENZAHL-1)
        switch (c)
        {
        case 'D':
          fprintf(fp,NEW_LINE);
          break;
        case 'W':
          fprintf(fp,"\n");
          break;
        }
      else
        for (abstand=0; abstand<SPALTENABSTAND; abstand++)
          fprintf(fp," ");
    }
  }
  for (spalte=0; spalte<SPALTENZAHL; spalte++) // FUSSZEILE
  {
    if (spalte==0)
      fprintf(fp,"");
    else
      fprintf(fp,"");
    fprintf(fp,"");
    if (spalte==SPALTENZAHL-1)
    {
      fprintf(fp,"");
      switch (c)
      {
      case 'D':
        fprintf(fp,NEW_LINE);
        break;
      case 'W':
        fprintf(fp,"\n");
        break;
      }
    }
    else
    {
      fprintf(fp,"");
      for (abstand=0; abstand<SPALTENABSTAND; abstand++)
        fprintf(fp,"");
    }
  }
  fprintf(fp,"\x0c");
  fclose(fp);
}
